//VARIABLES GLOBALES
var gameStateTime=30; //1 frame si vamos a 30 fps, 2 si vamos a 60 fps



//INCLUDES DEL SERVIDOR----------------------------------------------------------------------------------
var passwordHash = require('password-hash');
var fs = require('fs');
var keys = require('object-keys');
var app = require('express')();
//var exec = require('child_process').exec;
var net = require('net');
var http = require('http').Server(app);

var https        = require('https');
var server = https.createServer({
    key: fs.readFileSync(__dirname+'/cert/privkey.pem'),
    cert: fs.readFileSync(__dirname+'/cert/fullchain.pem'),
    requestCert: false,
    rejectUnauthorized: false
},app);



var ioHTTP = require('socket.io')(http,{pingInterval:500, pingTimeout: 5000, perMessageDeflate: false});
var ioHTTPS = require('socket.io')(server,{pingInterval:500, pingTimeout: 5000, perMessageDeflate: false});



//VARIABLES GLOBALES PARA EL SERVIDOR-------------------------------------------------------------------
var maxPlayersPerRoom=8; //numero de jugadores maximo por room
var lastId=0;
var clients=[];          //todos los clientes que estan conectados al servidor de alguna forma u otra
var roomClients=[];      //todas las rooms que estan activas en el servidor (cada room es a su vez un array de clientes)
var roomListIdr=[];		 //guarda una cadena con todos los idr del room, sirve para saber si un idr concreto esta en el room o no 
var roomLastIdr=[];      //guarda la ultima idr asignada (ojo guarda el indice del idrfor, no el valor)
var gs=[];               //GameState de todas las rooms (el game state debe guardar la info suficiente como para replicar el estado completo del juego en cualquier sitio)
var gsc=[]; 			 //marca true o false si esa propiedad se ha modificado desde el ultimo envio (remember, solo se va a enviar lo que cambie en el juego)
var gst=[]; 			 //ultimo momento en que se hizo un envio de gamestate, cada vez que se actualice el gs se comprobaran si han pasado x milisegundos a partir de este tiempo para saber si hay que preparar el nuevo envio de gs
var gstime=[]; 			 //momento en el que se creo la room, se usa para saber cuanto tiempo lleva la room creada
 // tabla de todos los posibles ids a usar en las rooms, las meto en un array por velocidad simplemente
var idrfor=['1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'];


//VARIABLES PARA LA DATABASE DEL SERVIDOR, SON HASHMAP CON FILAS DE DATOS
var database=[]; //es un hashmap de arrays, el key del hashmap es como si fuese el nombre de la tabla, y el array que contiene todas las filas
//dentro de cada fila se separaran los campos con el pipe | debemos tener funciones para insertar/buscar/filtrar










//CONTROL DE APACHE, PETICIONES WEB-------------------------------------------------------------------------------------

//PAGINA PRINCIPAL
app.get('/', function(req, res){
	console.log("PETICION HTTP: " + req.params[0]);
	res.set("Content-Type", "text/plain");
    res.set(200);
    res.set("Connection", "close");
    res.send("hello");
    res.end();
});

//EL RESTO DE RECURSOS, REDIRECCIONA DIRECTAMENTE AL RECURSO  ESTO LO MISMO NO HACE FALTA
app.get(/^(.+)$/, function(req, res){ 
	console.log("PETICION HTTP: "+ req.params[0]);
	try{
		res.sendFile( __dirname + req.params[0]);
	}catch(err){
		res.set("Content-Type", "text/plain");
	    res.set(200);
	    res.set("Connection", "close");
	    res.send("the file not exists");
	    res.end();
	}
	 
 });

 

 
 
 














//CAPA DE TRANSPORTE (HTTP, HTTPS, TCP)-------------------------------------------------------------------------------------------------------------------------------------- 

//CONEXION SOCKET.IO POR HTTP---------------------------------------------------------------------------
ioHTTP.on('connection', function(socket){
	
	var cliente=enterClientToServer("H", socket);
	

	socket.on('data', function (data) {
		processMsg(cliente, data);
	});
	
	//DESCONEXION DE PLAYER
	socket.on('disconnect', function () {
		leaveClientFromServer(cliente);
	});

	socket.on('error', function (err) {
		console.log('Client '+cliente.id+' ERROR: '+err);
		leaveClientFromServer(cliente);
	});
  
});


http.listen(8080, function(){
  console.log('ioHTTP listening on port 8080');
});






//CONEXION SOCKET.IO POR HTTPS---------------------------------------------------------------------------
ioHTTPS.on('connection', function(socket){
	
	var cliente=enterClientToServer("S", socket);
	

	socket.on('data', function (data) {
		processMsg(cliente, data);
	});

	//DESCONEXION DE PLAYER
	socket.on('disconnect', function () {
		leaveClientFromServer(cliente);
	});

	socket.on('error', function (err) {
		console.log('Client '+cliente.id+' ERROR: '+err);
		leaveClientFromServer(cliente);
	});
  
});

server.listen(8880, function(){
	console.log('ioHTTPS listening on port 8880');
});







//CONEXION POR TCP/IP DIRECTA---------------------------------------------------------------------------
var serverTCP = net.createServer(function (socket) {

	var cliente=enterClientToServer("T", socket);
	
	socket.on('data', function (data) {
		cliente.stack=cliente.stack+data;
		while(cliente.stack.indexOf("#")>-1)
		{
			var men=cliente.stack.substring(0,cliente.stack.indexOf("#"));
			cliente.stack=cliente.stack.substring(cliente.stack.indexOf("#")+1,cliente.stack.length);
			processMsg(cliente, men);
		}
	});

	// Remove the client from the list when it leaves
	socket.on('end', function () {
		leaveClientFromServer(cliente);
	});

	
	socket.on('error', function (err) {
		console.log('Client '+socket.id+' TCPsocket ERROR: '+err);
		leaveClientFromServer(cliente);
	});
});

serverTCP.on('error', (err) => {
	console.log('FATAL ERROR, TCPserver ERROR: '+err);
});

serverTCP.listen(8888,function(){
	console.log('TPC listening on port 8888');
});


















//MANEJO DE CLIENTES-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
//funcion simple para generar id s
function getNewId()
{
	lastId=lastId+1;
	return ""+lastId;
}


//agregamos un cliente al servidor y lo devolvemos
function enterClientToServer(tipo, socket)
{
	var cliente={id:tipo+getNewId(), idr:"", type:tipo, sock:socket, room:"", game:"", stack:"", user:"", login:false };
	clients[cliente.id]=cliente.id;
	socket.id=cliente.id;
	
	console.log("Client "+cliente.id+" new connection");
	return cliente; //devolvemos el objeto cliente, tambien se queda en el array clients que tiene todos los clientes del servidor
}

//salimos del servidor (ojo que puede ser por un error de conexion)
function leaveClientFromServer(cliente)
{
	console.log("Client "+cliente.id+" disconnect");
	leaveClientFromRoom(cliente); //antes de sacarlo del servidor tenemos que sacarlos de las room
	clients.splice(clients.indexOf(cliente.id), 1);	//despues lo sacamos de la lista de clientes
}

//entramos en una room (ojo, solo entramos si esta dentro de algun juego, sino no le permitimos entrar)
function enterClientToRoom(cliente, room, limit)
{
	if(room!="")
	{
		if(roomClients[room])
		{
			//si existe lo metemos del tiron
			if(roomClients[room].length<parseInt(limit))
			{
				cliente.room=room;
				roomLastIdr[room]=roomLastIdr[room]+1;
				if(roomLastIdr[room]>=idrfor.length)
				{
					roomLastIdr[room]=0;
				}
				cliente.idr=idrfor[roomLastIdr[room]];
				roomClients[room].push(cliente);
				roomListIdr[room]=roomListIdr[room]+cliente.idr;
				responseToClient(cliente, "si|room|enter|"+room+"|"+cliente.idr); //server information, sobre rooms, has entrado en la room con tal idr
				console.log("Client "+cliente.id+" enter room "+room+" with idr "+cliente.idr);
				responseToRoom(cliente, "si|room|in|"+cliente.idr);
			}else{
				responseToClient(cliente, "si|room|full"); //server information, sobre rooms, full room sala llena
				console.log("Client "+cliente.id+" failed enter room "+room+" limit "+limit+" exceded");
			}
		}else{
			//si no existe creamos la room y lo metemos
			roomClients[room]=[];
			roomLastIdr[room]=0;
			gs[room]=[];
			gsc[room]=[];
			gst[room]=Date.now()+gameStateTime;
			gstime[room]=Date.now();
			cliente.room=room;
			cliente.idr=idrfor[roomLastIdr[room]];
			roomClients[room].push(cliente);
			roomListIdr[room]=""+cliente.idr;
			responseToClient(cliente, "si|room|enter|"+room+"|"+cliente.idr); //server information, sobre rooms, has entrado en la room con tal idr
			console.log("Client "+cliente.id+" create room "+room+" with idr "+cliente.idr);
		}
	}else{
		var haEntrado=false;
		var arrkeys=keys(roomClients);
		for(var i=0; i<arrkeys.length; i++)
		{
			//si la room es del mismo juego del cliente
			if(arrkeys[i].startsWith(cliente.game+"_"))
			{
				//si la room aun no esta petada
				if(roomClients[arrkeys[i]].length<parseInt(limit))
				{
					//entramos
					haEntrado=true;
					
					var roomSel=arrkeys[i];
					cliente.room=roomSel;
					roomLastIdr[roomSel]=roomLastIdr[roomSel]+1;
					if(roomLastIdr[roomSel]>=idrfor.length)
					{
						roomLastIdr[roomSel]=0;
					}
					cliente.idr=idrfor[roomLastIdr[roomSel]];
					roomClients[roomSel].push(cliente);
					roomListIdr[roomSel]=roomListIdr[room]+cliente.idr;
					responseToClient(cliente, "si|room|enter|"+roomSel+"|"+cliente.idr); //server information, sobre rooms, has entrado en la room con tal idr
					console.log("Client "+cliente.id+" enter room "+roomSel+" with idr "+cliente.idr);
					responseToRoom(cliente, "si|room|in|"+cliente.idr);
					break;
				}
			}
		}
		
		if(haEntrado==false)
		{
			//creamos una room con id random
			var roomSel=cliente.game+"_R"+getNewId();
			roomClients[roomSel]=[];
			roomLastIdr[roomSel]=0;
			gs[roomSel]=[];
			gsc[roomSel]=[];
			gst[roomSel]=Date.now()+gameStateTime;
			gstime[roomSel]=Date.now();
			cliente.room=roomSel;
			cliente.idr=idrfor[roomLastIdr[roomSel]];
			roomClients[roomSel].push(cliente);
			roomListIdr[roomSel]=""+cliente.idr;
			responseToClient(cliente, "si|room|enter|"+roomSel+"|"+cliente.idr); //server information, sobre rooms, has entrado en la room con tal idr
			console.log("Client "+cliente.id+" create room "+roomSel+" with idr "+cliente.idr);
		}
	}	
}


function listRooms(cliente)
{
	var roomlist="";
	var arrkeys=keys(roomClients);
	for(var i=0; i<arrkeys.length; i++)
	{
		//si la room es del mismo juego del cliente
		if(arrkeys[i].startsWith(cliente.game+"_"))
		{
			roomlist=roomlist+"|"+arrkeys[i];
		}
	}
	
	if(roomlist!="")
	{
		responseToClient(cliente, "si|room|list"+roomlist); //server information, sobre rooms, lista de rooms disponibles del juego en el que estas
	}else{
		responseToClient(cliente, "si|room|emptylist"); //server information, sobre rooms, no hay salas
	}
}

function leaveClientFromRoom(cliente)
{
	if(cliente.room!="")
	{
		console.log("Client "+cliente.id+" leave room "+cliente.room);
		var ind=roomClients[cliente.room].indexOf(cliente);
		roomClients[cliente.room].splice(ind, 1);
		roomListIdr[cliente.room]=roomListIdr[cliente.room].replace(cliente.idr,"");
		//si ademas la room se queda vacia nos la pelamos por completo
		if(roomClients[cliente.room].length==0)
		{
			delete roomClients[cliente.room];
			delete roomListIdr[cliente.room];
			delete gs[cliente.room];
			delete gsc[cliente.room];
			
			console.log("Client "+cliente.id+" destroy room "+cliente.room);
		}else{
			//aluckardo hay que acabar esto, debe eliminar las keys que empiecen por nuestro idr
			var arrkeys=keys(gs[cliente.room]);
			for(var i=0; i<arrkeys.length; i++)
			{
				if(arrkeys[i].startsWith(cliente.idr))
				{
					delete gs[cliente.room][arrkeys[i]];
					delete gsc[cliente.room][arrkeys[i]];
				}	
			}
			responseToRoom(cliente, "si|room|out|"+cliente.idr); //si aun queda alguien en la room avisamos que nos piramos
		}
		cliente.room="";
	}
}
















//MANEJO DE LOGIN Y USERS---------------------------------------------------------------
function createUser(cliente, login,pass)
{
	//si no ha entrado en ningun juego no hacemos ningun login
	if(cliente.game!="")
	{
		//el usuario no puede estar jugando cuando cree el usuario
		if(cliente.login==false)
		{
			//no permitimos ni nombres de usuarios largos ni claves largas
			if(login.length<16 && pass.length<16)
			{
				var letterNumber = /^[0-9a-zA-Z]+$/;
				if(login.match(letterNumber) && pass.match(letterNumber))
				{
					try{
						//MIRAMOS SI EXISTE EL ARCHIVO DEL USUARIO
						fs.open(__dirname+'/data/'+cliente.game+'_'+login+'_user', 'wx', (err, fd) => {
							if (err) {
								//ERROR CONTROLADO, EL ARCHIVO YA EXISTE NO PODEMOS VOLVER A CREAR EL USUARIO
								responseToClient(cliente, "lu|FAIL|user already exists"); 
								console.error('intento de crear usuario repetido:'+login+'|'+pass); //SI EXISTE NO PODEMOS CREARLO
							}else{
								fs.writeFile(__dirname+'/data/'+cliente.game+'_'+login+'_user', pass, function(err) {
								    if(err) {
								    	throw err; //lanzamos pa fuera
								    }else{
								    	responseToClient(cliente, "lu|OK|user created");
								    }
								});
							}
						});
					} catch (err) {
						console.error('fallo al crear un usuario:'+login+'|'+pass); //SI EXISTE NO PODEMOS CREARLO
				    	console.log(err);
				    	responseToClient(cliente, "lu|FAIL|error creating user"); 
					}
				}else{
					responseToClient(cliente, "lu|FAIL|only chars A-Z a-z 0-9"); 
				}
			}
		}
	}
}



function loginUser(cliente, login,pass)
{
	//si no ha entrado en ningun juego no hacemos ningun login
	if(cliente.game!="")
	{
		//el usuario no puede estar jugando cuando cree el usuario
		if(cliente.login==false)
		{
			//no permitimos ni nombres de usuarios largos ni claves largas
			if(login.length<16 && pass.length<16)
			{
				var letterNumber = /^[0-9a-zA-Z]+$/;
				if(login.match(letterNumber) && pass.match(letterNumber))
				{
					try{
						//LEEMOS EL ARCHIVO Y SI EL CONTENIDO ES IGUAL QUE EL PASS PA ENTRO
						fs.readFile(__dirname+'/data/'+cliente.game+'_'+login+'_user', (err, data) => {
							if (err) throw err;
							if(data==pass)
							{
								responseToClient(cliente, "lu|OK|login ok");
								cliente.login=true;
								cliente.user=login;
							}else{
								responseToClient(cliente, "lu|FAIL|invalid user or password");
								cliente.login=false;
								cliente.user='';
							}
						});
					} catch (err) {
						console.error('fallo al logarse un usuario:'+login+'|'+pass); //SI EXISTE NO PODEMOS CREARLO
				    	console.log(err);
				    	responseToClient(cliente, "lu|FAIL|invalid user or password");
					}
				}else{
					responseToClient(cliente, "lu|FAIL|only chars A-Z a-z 0-9"); 
				}
			}
		}
	}
}





//FUNCION PARA SABER QUIEN ESTA CONECTADO A LA ROOM
function roomList(cliente)
{
	if(roomClients[cliente.room])
	{
		console.log("roomList en preparacion");
		var listaClientes="rl";	
		for(var i=0; i<roomClients[cliente.room].length; i++)
		{
			listaClientes=listaClientes+"|"+roomClients[cliente.room][i].user+"|"+roomClients[cliente.room][i].idr;
		}
		console.log("roomList respuesta "+listaClientes);
		responseToClient(cliente, listaClientes); 
	}
}


















//MANEJO DEL GAME STATE------------------------------------------------------------------------------------------------------------------------------
function setGameState(cliente, arr)
{
	if(cliente.game!="" && cliente.room!="")
	{
		if(roomClients[cliente.room])
		{
			for(var i=1; i<arr.length; i++)
			{
				var auxStr=arr[i];
				console.log("insertando gs: "+auxStr);
				gs[cliente.room][auxStr.substr(0,2)]=auxStr.substr(2,auxStr.length-2);
				gsc[cliente.room][auxStr.substr(0,2)]=true;
			}

			//si ya toca mandar el gs a todos porque han pasado x milisegundos, pues preparamos el mensaje del gs y se lo mandamos a todos los de la room
			if(Date.now()>gst[cliente.room])
			{
				//SETEAMOS EL ROOM_TIME_ALIVE (milisegundos desde que se creo el room)
				gs[cliente.room]['00']=(Date.now()-gstime[cliente.room]);
				gsc[cliente.room]['00']=true;
			
				//PREPARAMOS EL MENSAJE DEL GS gsMessage
				var gsMessage="";
				for(var i in gs[cliente.room])
				{
					if(gsc[cliente.room][i]==true)
					{
						console.log("creando gs: i="+i+" gs="+gs[cliente.room][i]);
						gsMessage=gsMessage+'|'+i+gs[cliente.room][i];
						gsc[cliente.room][i]=false; //no se vuelve a mandar hasta que no se vuelva a cambiar
					}
				}
				gst[cliente.room]=Date.now()+gameStateTime;
				console.log('SIOgs'+gsMessage);
				responseToRoom(cliente, "si|gs"+gsMessage); //server information, sobre rooms, game state (cambios en el estado del juego)
				responseToClient(cliente, "si|gs"+gsMessage); //Se lo digo al resto del room y a mi tambien por supuesto
			}
		}
	}
}


//FULL GAMESTATE
function getGameState(cliente)
{
	if(cliente.game!="" && cliente.room!="")
	{
		if(roomClients[cliente.room])
		{
			//PREPARAMOS EL MENSAJE DEL GS gsMessage
			var gsMessage="";
			for(var i in gs[cliente.room])
			{
				gsMessage=gsMessage+'|'+i+gs[cliente.room][i];
			}
			console.log('full GS '+gsMessage);
			responseToClient(cliente, "si|gs"+gsMessage); //me envio el full gamestate para refrescar todo mi juego
		}
	}
}











//CONTROL DE MENSAJES DIRECTOS (sin usar gamestate, aunque no se recomienda para determinados mensajes largos es mejor no llenar el gs)
function sendMessageDirect(cliente, fullmessage)
{
	if(cliente.game!="" && cliente.room!="")
	{
		if(roomClients[cliente.room])
		{
			var men=fullmessage.substring(3,fullmessage.length);
			//console.log("MESG:"+men);
			responseToRoom(cliente, men);
		}
	}
}













//PROCESADO GENERAL DE MENSAJES--------------------------------------------------------------------------------------------------------------------------------------
function responseToClient(cliente, message)
{
	if(cliente.type=="T"){
		cliente.sock.write(message+"#");
	}else if(cliente.type=="H"){
		cliente.sock.emit('data',message);
	}else if(cliente.type=="S"){
		cliente.sock.emit('data',message);
	}
}


function responseToRoom(cliente, message)
{
	//roomClients
	if(cliente.type=="T"){
		for(var i=0; i<roomClients[cliente.room].length; i++)
		{
			if(roomClients[cliente.room][i].id!=cliente.id)
			{
				roomClients[cliente.room][i].sock.write(message+"#");
			}
		}
	}else if(cliente.type=="H"){
		for(var i=0; i<roomClients[cliente.room].length; i++)
		{
			if(roomClients[cliente.room][i].id!=cliente.id)
			{
				roomClients[cliente.room][i].sock.emit('data',message);
			}
		}
	}else if(cliente.type=="S"){
		for(var i=0; i<roomClients[cliente.room].length; i++)
		{
			if(roomClients[cliente.room][i].id!=cliente.id)
			{
				roomClients[cliente.room][i].sock.emit('data',message);
			}
		}
	}
}

function processMsg(cliente, message)
{
	//var cad=""+message;
	//console.dir(cad);
	//console.log("Client "+cliente.id+" incomming "+message);
	try{
		var p=message.split("|");
		if(message.length<20)
		{
			console.log("INCOMMING:"+message);
		//}else{
			//console.log("INCOMMING L:"+message.substring(0,20));
		}
		//SET GAME
		if(p[0]=="sg")
		{
			if(p[1]!="")
			{
				cliente.game=p[1];
				console.log("Client "+cliente.id+" SET GAME "+p[1]);
			}
		}else if(p[0]=="sr"){
			if(cliente.game!="")
			{
				if(p[1]!="" && p[2]!="")
				{
					leaveClientFromRoom(cliente); //primero salimos si estuviesemos en alguna room
					enterClientToRoom(cliente, cliente.game+"_"+p[1],p[2]);
					console.log("Client "+cliente.id+" SET ROOM "+cliente.game+"_"+p[1]);
				}else if(p[1]==""){
					console.log("Client "+cliente.id+" EXITS ROOM "+cliente.room);
					leaveClientFromRoom(cliente); //SI PASAMOS EL NOMBRE DE LA ROOM EN BLANCO NOS SALIMOS DE LA ROOM
				}
			}
		}else if(p[0]=="er"){
			if(cliente.game!="")
			{
				if(p[1]!="")
				{
					enterClientToRoom(cliente, "",p[1]);
					console.log("Client "+cliente.id+" ENTER ROOM");
				}
			}
		}else if(p[0]=="lr"){
			if(cliente.game!="")
			{
				listRooms(cliente);
				console.log("Client "+cliente.id+" LIST ROOMS");
			}
		}else if(p[0]=="rl"){
			if(cliente.game!="" && cliente.room!="")
			{
				roomList(cliente); //lista la gente que esta en esa room
				console.log("Client "+cliente.id+" ROOM LIST");
			}
			
		}else if(p[0]=="sgs"){
			if(cliente.game!="" && cliente.room!="")
			{
				setGameState(cliente,p);
			}
		}else if(p[0]=="ggs"){
			if(cliente.game!="" && cliente.room!="")
			{
				getGameState(cliente);
			}
		}else if(p[0]=="sm"){
			if(cliente.game!="" && cliente.room!="")
			{
				sendMessageDirect(cliente,message); //ojo que aqui pasamos el mensaje tal cual completo
			}
		}else if(p[0]=="cu"){
			createUser(cliente, p[1],p[2]);
		}else if(p[0]=="lu"){
			loginUser(cliente, p[1],p[2]);
		}else if(p[0]=="fms"){
			//file manager save (OJITO CON ESTO, DEBE TENER MUUUUCHA SECURITY PARA QUE NADIE LA LIE)
			saveDataFileSystem(cliente,p[1],p[2]);//pasamos cliente, el nombre del archivo y los datos que quiere guardar (una cadena)
		}else if(p[0]=="fml"){
			//file manager load (ojo para que nadie lea lo que no debe)
			loadDataFileSystemAndSendIt(cliente,p[1]); //pasamos cliente y el nombre del archivo, al leerlo se lo enviara
		}else if(p[0]=="fmd"){
			//file manager dir (ojito que esto no deberia usarlo ningun jugador)
			loadDirFileSystemAndSendIt(cliente,p[1]);
		}
	}catch(err){
		console.log("Client "+cliente.id+" incomming error "+err+" IN DATA "+message);
	}
}



















//FILESYSTEM FUNCTIONS---------------------------------------------------------------
function saveDataFileSystem(cliente,filename,data)
{
	try{
		//si no ha entrado en ningun juego no hacemos nada
		if(cliente.game!="")
		{
			//logado
			if(cliente.login==true)
			{
				fs.writeFile(__dirname+'/data/'+cliente.game+'_'+cliente.user+'_'+filename, data, function(err) {
				    if(err) {
						console.log(err);
						responseToClient(cliente, "fms|FAIL|error saving data");
				    }else{
				    	responseToClient(cliente, "fms|OK|data saved");
				    }
				}); 
			}
		}
	}catch(err){
		console.log(err);
		responseToClient(cliente, "fms|FAIL|error saving data");
	}
}




function loadDataFileSystemAndSendIt(cliente, filename)
{
	try{
		//si no ha entrado en ningun juego no hacemos nada
		if(cliente.game!="")
		{
			//logado
			if(cliente.login==true)
			{
				fs.readFile(__dirname+'/data/'+cliente.game+'_'+cliente.user+'_'+filename, {encoding: 'utf-8'}, function(err,data){
				    if (err) {
				        console.log(err);
						responseToClient(cliente, "fml|FAIL|error loading data");
				    }else{
				    	responseToClient(cliente, "fml|OK|"+data);
				    }
				});
			}
		}
	}catch(err){
		console.log(err);
		responseToClient(cliente, "fml|FAIL|error loading data");
	}
}




function loadDirFileSystemAndSendIt(cliente,filtro)
{
	if(filtro=='')
	{
		filtro=cliente.game+'_'+cliente.user+'_';
		console.log(filtro);
	}
	try{
		//si no ha entrado en ningun juego no hacemos nada
		if(cliente.game!="")
		{
			//logado
			if(cliente.login==true)
			{
				fs.readdir(__dirname+'/data/', {encoding: 'utf-8'}, function(err,data){
				    if (err) {
				        console.log(err);
						responseToClient(cliente, "fmd|FAIL|error loading data");
				    }else{
				    	var cad="";
				    	for(var i=0; i<data.length; i++)
				    	{
				    		//console.log("COMPARING "+data[i]+" CON "+filtro);
				    		if(data[i].startsWith(filtro))
				    		{
				    			cad=cad+"|"+data[i].replace(cliente.game+'_'+cliente.user+'_', '');
				    		}
				    	}
				    	responseToClient(cliente, "fmd|OK"+cad);
				    }
				});
			}
		}
	}catch(err){
		console.log(err);
		responseToClient(cliente, "fmd|FAIL|error loading data");
	}
}









//DATABASE FUNCTIONS-------------------------------------------------------------------------------------------------------
//carga todos los archivos y los mete en el hashmap
function dbReloadFromDisk()
{
	//1- recorre todos los archivos
		//2- por cada archivo
		//3- lee el contenido del archivo
		//4- mete el contenido en una cadena
		//5- mete la cadena en el hashmap con el nombre del archivo como key
}


//guarda la base de datos en archivos, opcionalmente se le puede especificar una tabla concreta, sino se especifica guardara toda la base de datos
function dbSaveToDisk(tableName)
{
	
}


//devuelve las filas de la tabla que coincidan con los filtros, los filtros se especificaran diciendo la columna y el valor que debe tener 2|juan
//o blanco si se quieren todas las filas, se pueden usar varios filtros, las filas seran devueltas separadas por un salto de linea
function dbFindRows(tableName, filtersString)
{
}

//busca en toda la tabla si existe la cadena pasada y devuelve la fila donde esta esa cadena
function dbFindString(tableName, findString)
{
}


//inserta una fila en la base de datos al final de la tabla
function dbInsertRow(tableName, rowString)
{
}

//inserta una fila en orden, pilla el campo por el que se va a ordenar y va recorriendo la tabla hasta que encuentra el hueco y mete la fila en ese hueco
//si se va a insertar en orden lo suyo es que siempre se haga en orden
function dbInsertWithOrderRow(tableName, rowString, orderString)
{
}

//funcion que elimina las filas a partir del numero especificado en numberRows (se va a usar para capar los rankings)
function dbTruncateTable(tableName, numberRows)
{
}










console.log('Starting server, please wait...');
